<?php 

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class RelTotalVendasNivelProd {
	
	protected $entityManager; 
	public $timeout = 600;
            
	public function __construct(EntityManager $entityManager)  {

		$this->entityManager = $entityManager;
	}
	    
	public function maxNivProd() {
        $resultQuery = $this->entityManager->getConnection()->fetchAll(self::MAX_NIV_PROD)[0]['CDNVPRODUTO'];
        return $resultQuery;
    }
	
	public function getIntervalo($params) {
        $resultQuery = $this->entityManager->getConnection()->fetchAll(self::GET_INTERVALO, $params);
        
        for($i = 0; $i < count($resultQuery); $i++) {
            $produtos[] = $resultQuery[$i]['CDARVPROD'];
        }
        
        $produtos = implode('_', $produtos);
        
        return $produtos;
    }

	private function setReportParameters(&$params, &$arrayAssocWithParams) {
		$params = array(
			':DTVENDAINI' => $arrayAssocWithParams['DTVENDAINI'],
			':DTVENDAFIN' => $arrayAssocWithParams['DTVENDAFIN'],
			':CDFILIAL' => $arrayAssocWithParams['CDFILIAL'],
			':TCDFILIAL' => $arrayAssocWithParams['TCDFILIAL'],
			':CDCAIXA' => $arrayAssocWithParams['CDCAIXA'],
			':TCDCAIXA' => $arrayAssocWithParams['TCDCAIXA'],
			':CDCLIENTE' => $arrayAssocWithParams['CDCLIENTE'],
			':TCDCLIENTE' => $arrayAssocWithParams['TCDCLIENTE'],
			':CDCONSUMIDOR' => $arrayAssocWithParams['CDCONSUMIDOR'],
			':TCDCONSUMIDOR' => $arrayAssocWithParams['TCDCONSUMIDOR'],
			':CDVENDEDOR' => $arrayAssocWithParams['CDVENDEDOR'],
			':TCDVENDEDOR' => $arrayAssocWithParams['TCDVENDEDOR'],
			':CDNVPRODUTO' => $arrayAssocWithParams['CDNVPRODUTO'],
			':CDPRODS' => $arrayAssocWithParams['CDPRODS'],
			':TCDPRODUTO' => $arrayAssocWithParams['TCDPRODUTO'],
			':CDARVPRODI' => $arrayAssocWithParams['CDARVPRODI'],
			':CDARVPRODF' => $arrayAssocWithParams['CDARVPRODF'],
			':NRORG' => $arrayAssocWithParams['NRORG']
		);
	} 
	
	public function geraRelatorio($arrayAssocWithParams) {
		set_time_limit(120);
		$params = [];
		$tipo = $arrayAssocWithParams['TIPORELATORIO'];
		$this->setReportParameters($params, $arrayAssocWithParams);
		if ($tipo == 'S'){
			$PERCENTBASE = $this->entityManager->getConnection()->fetchAll(self::PERCENT_SINTETICO, $params);
		} else{
			$PERCENTBASE = $this->entityManager->getConnection()->fetchAll(self::PERCENT, $params);
		}
		if ($tipo == 'S'){
			$valorTOTAL = $productsByLevel = $this->entityManager->getConnection()->fetchAll(self::REL_TOTAL_VENDAS_NIVEL_PROD_SINTETICO, $params);
		} else{
			$valorTOTAL = $productsByLevel = $this->entityManager->getConnection()->fetchAll(self::REL_TOTAL_VENDAS_NIVEL_PROD, $params);
		}
		$PERCENTBASE = isset($PERCENTBASE) ? array_column($PERCENTBASE, null, 'CDFILIALPERCENT') : 1;
		
		foreach ($valorTOTAL as &$data) {
			if($data['CDFILIALPERCENT'] == $PERCENTBASE[$data['CDFILIALPERCENT']]['CDFILIALPERCENT']){
				$data["PERCENTUAL"] = (($data["VALOR"])/$PERCENTBASE[$data['CDFILIALPERCENT']]['VALOR'])*100;
				//$data['PERCENTPES'] = number_format((($data["QTDE"])/$data["NRPESMESAVENDA"])*100, 2, '.', '');
			}
		}
		return !$valorTOTAL ? [] : $valorTOTAL ;
	}
	
	private function totalVenda ($result){
		$total = 0;
		foreach ($result as $value) {
			$total += $value['VALOR'];
		}
		return $total;
	}
	
	const MAX_NIV_PROD = "
		SELECT MAX(CDNVPRODUTO) AS CDNVPRODUTO FROM PRODUTO
	";
	
	const GET_INTERVALO = "
        SELECT CDARVPROD FROM PRODUTO WHERE CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM
    ";
	  
	const REL_TOTAL_VENDAS_NIVEL_PROD = "
		SELECT PP.CDARVPROD AS CDARVPRODREPORT, PP.CDARVPROD, I.CDPRODUTO, PP.NMPRODUTO, PP.CDNVPRODUTO,
			   FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL AS CDFILIALPERCENT, FILOCAVE.NMFILIAL, FILOCAVE.NRORG,
			   PP.SGUNIDADE, SUM(I.VRACRITVEND) AS ACRESCIMO, SUM(I.QTPRODVEND)  AS QTDE,
			   FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL  AS CDFILIAL, FILOCAVE.NRPESMESAVENDA,
			   SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) - NVL(I.VRDESITVEND,0),2)) AS VALOR,
			   TRUNC(((SUM(I.QTPRODVEND)/CASE NVL(FILOCAVE.NRPESMESAVENDA, 1) WHEN 0 THEN 1 END)*100),2) AS PERCENTPES, 
			   P4.CDARVPROD AS CDARVPRODP4, P4.CDPRODUTO AS CDPRODUTOP4, P4.NMPRODUTO AS NMPRODUTOP4, P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4,
    		   P1.CDARVPROD AS CDARVPRODP1, P1.CDPRODUTO AS CDPRODUTOP1, P1.NMPRODUTO AS NMPRODUTOP1, P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1,
    		   P2.CDARVPROD AS CDARVPRODP2, P2.CDPRODUTO AS CDPRODUTOP2, P2.NMPRODUTO AS NMPRODUTOP2, P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2,
    		   P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3, P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3,
    		   PP.CDARVPROD AS CDARVPRODP5, PP.CDPRODUTO AS CDPRODUTOP5, PP.NMPRODUTO AS NMPRODUTOP5, PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
		  FROM ITEMVENDA I
		  JOIN PRODUTO PP
			ON I.CDPRODUTO = PP.CDPRODUTO
		   LEFT JOIN PRODUTO P4
	        ON PP.CDPRODNIVANTE = P4.CDARVPROD
	      LEFT JOIN PRODUTO P3
	        ON P4.CDPRODNIVANTE = P3.CDARVPROD
          LEFT JOIN PRODUTO P2
	        ON P3.CDPRODNIVANTE = P2.CDARVPROD
	      LEFT JOIN PRODUTO P1
	        ON P2.CDPRODNIVANTE = P1.CDARVPROD
	     
		  JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
					   FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, SUM(NVL(V.NRPESMESAVENDA,0)) OVER (PARTITION BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV) AS NRPESMESAVENDA
				  FROM VENDA V
				  JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
						   FROM CAIXA C
						   JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
									FROM LOJA L
									JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
											FROM FILIAL F
											WHERE ((INSTR(:CDFILIAL, F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
											  AND F.NRORG = :NRORG ) FI
									  ON L.CDFILIAL = FI.CDFILIAL
									 ) FILO
							 ON C.CDFILIAL = FILO.CDFILIAL
							AND C.CDLOJA = FILO.CDLOJA
						
							AND ((INSTR(:CDCAIXA, FILO.CDFILIAL||C.CDCAIXA) <> 0 ) OR (:TCDCAIXA = 'T'))) FILOCA
					 ON V.CDCAIXA = FILOCA.CDCAIXA
					AND V.CDLOJA = FILOCA.CDLOJA
					AND V.CDFILIAL = FILOCA.CDFILIAL
			
				  WHERE V.IDSITUVENDA = 'O'
					AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
					AND ((INSTR(:CDCLIENTE, V.CDFILIAL||'_'||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
					AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE||'_'||V.CDCONSUMIDOR) <> 0 ) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
			ON FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
		   AND FILOCAVE.CDCAIXA = I.CDCAIXA
		   AND FILOCAVE.CDFILIAL = I.CDFILIAL
	
		 WHERE I.CDPRODUTO <> NVL(FILOCAVE.CDPRODTAXASERV , 0)
		   AND ((:TCDPRODUTO = 'T') OR (INSTR(:CDPRODS, PP.CDARVPROD) <> 0) OR (PP.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))
		 GROUP BY PP.CDARVPROD, PP.NMPRODUTO, PP.CDNVPRODUTO, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRORG, PP.SGUNIDADE, FILOCAVE.NRPESMESAVENDA,
               P4.CDARVPROD,P3.CDARVPROD,P2.CDARVPROD,P1.CDARVPROD,P4.CDPRODUTO,P3.CDPRODUTO,P2.CDPRODUTO,P1.CDPRODUTO,P4.NMPRODUTO,P3.NMPRODUTO,P2.NMPRODUTO,P1.NMPRODUTO,
               PP.CDARVPROD, PP.CDPRODUTO, PP.NMPRODUTO, I.CDPRODUTO
		 ORDER BY FILOCAVE.CDFILIAL, PP.CDARVPROD
   " ;
	  
	const PERCENT = "
		SELECT FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL AS CDFILIALPERCENT, SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) - NVL(I.VRDESITVEND,0),2)) AS VALOR
		  FROM ITEMVENDA I
		  JOIN PRODUTO PP
			ON I.CDPRODUTO = PP.CDPRODUTO
		  LEFT JOIN PRODUTO P4
	        ON PP.CDPRODNIVANTE = P4.CDARVPROD
	      LEFT JOIN PRODUTO P3
	        ON P4.CDPRODNIVANTE = P3.CDARVPROD
	      LEFT JOIN PRODUTO P2
	        ON P3.CDPRODNIVANTE = P2.CDARVPROD
	      LEFT JOIN PRODUTO P1
	        ON P2.CDPRODNIVANTE = P1.CDARVPROD
            
		  JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
					   FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, SUM(NVL(V.NRPESMESAVENDA,0)) OVER (PARTITION BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV) AS NRPESMESAVENDA
				  FROM VENDA V
				  JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
						   FROM CAIXA C
						   JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
									FROM LOJA L
									JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
											FROM FILIAL F
											WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
											  AND F.NRORG = :NRORG ) FI
									  ON L.CDFILIAL = FI.CDFILIAL) FILO
							 ON C.CDFILIAL = FILO.CDFILIAL
							AND C.CDLOJA = FILO.CDLOJA
							AND ((INSTR(:CDCAIXA, FILO.CDFILIAL||C.CDCAIXA) <> 0 ) OR (:TCDCAIXA = 'T'))) FILOCA
					 ON V.CDCAIXA = FILOCA.CDCAIXA
					AND V.CDLOJA = FILOCA.CDLOJA
					AND V.CDFILIAL = FILOCA.CDFILIAL
				  WHERE V.IDSITUVENDA = 'O'
					AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
					AND ((INSTR(:CDCLIENTE, V.CDFILIAL||'_'||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
					AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE||'_'||V.CDCONSUMIDOR) <> 0 ) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
			ON FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
		   AND FILOCAVE.CDCAIXA = I.CDCAIXA
		   AND FILOCAVE.CDFILIAL = I.CDFILIAL
		 WHERE I.CDPRODUTO <> NVL(FILOCAVE.CDPRODTAXASERV , 0)
		   AND (( :TCDPRODUTO = 'T') OR (INSTR(:CDPRODS, PP.CDARVPROD) <> 0) OR (PP.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))
		 GROUP BY FILOCAVE.CDFILIAL
		 ORDER BY FILOCAVE.CDFILIAL
   " ;
	  
	const PERCENT_SINTETICO = "
		SELECT 'Todos' AS CDFILIAL,  :CDFILIAL AS CDFILIALPERCENT,  SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) - NVL(I.VRDESITVEND,0),2)) AS VALOR
		  FROM ITEMVENDA I
		  JOIN PRODUTO PP
			ON I.CDPRODUTO = PP.CDPRODUTO
		  LEFT JOIN PRODUTO P4
	        ON PP.CDPRODNIVANTE = P4.CDARVPROD
	      LEFT JOIN PRODUTO P3
	        ON P4.CDPRODNIVANTE = P3.CDARVPROD
	      LEFT JOIN PRODUTO P2
	        ON P3.CDPRODNIVANTE = P2.CDARVPROD
	      LEFT JOIN PRODUTO P1
	        ON P2.CDPRODNIVANTE = P1.CDARVPROD
	        
		  JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
					   FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, SUM(NVL(V.NRPESMESAVENDA,0)) OVER (PARTITION BY FILOCA.NRORG) AS NRPESMESAVENDA
				  FROM VENDA V
				  JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
						   FROM CAIXA C
						   JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
									FROM LOJA L
									JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
											FROM FILIAL F
											WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
											  AND F.NRORG = :NRORG ) FI
									  ON L.CDFILIAL = FI.CDFILIAL
									 AND L.NRORG = FI.NRORG ) FILO
							 ON C.CDFILIAL = FILO.CDFILIAL
							AND C.CDLOJA = FILO.CDLOJA
							AND ((INSTR(:CDCAIXA, FILO.CDFILIAL||C.CDCAIXA) <> 0 ) OR (:TCDCAIXA = 'T'))) FILOCA
					 ON V.CDCAIXA = FILOCA.CDCAIXA
					AND V.CDLOJA = FILOCA.CDLOJA
					AND V.CDFILIAL = FILOCA.CDFILIAL
				  WHERE V.IDSITUVENDA = 'O'
					AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
					AND ((INSTR(:CDCLIENTE, V.CDFILIAL||'_'||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
					AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE||'_'||V.CDCONSUMIDOR) <> 0 ) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
			ON FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
		   AND FILOCAVE.CDCAIXA = I.CDCAIXA 
		   AND FILOCAVE.CDFILIAL = I.CDFILIAL
		 WHERE I.CDPRODUTO <> NVL(FILOCAVE.CDPRODTAXASERV , 0)
		   AND (( :TCDPRODUTO = 'T') OR (INSTR(:CDPRODS, PP.CDARVPROD) <> 0) OR (PP.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))  
   " ;
	  
	const GET_MAX_STRLENGTH_OF_CDARVPROD_BY_CDNVPRODUTO = "
		SELECT MAX(LENGTH(CDARVPROD)) AS NIVELLENGTH
		  FROM PRODUTO  
		  WHERE (CDNVPRODUTO <= :CDNVPRODUTO
			 OR  :TCDNVPRODUTO = 'T')
			AND NRORG = :NRORG
		  GROUP BY CDNVPRODUTO
	  ORDER BY NIVELLENGTH ASC
	";

	const REL_TOTAL_VENDAS_NIVEL_PROD_SINTETICO = "
	  	SELECT PP.CDARVPROD AS CDARVPRODREPORT, PP.CDARVPROD, I.CDPRODUTO, PP.NMPRODUTO, PP.CDNVPRODUTO,
           'Todas' AS CDFILIAL, :CDFILIAL AS CDFILIALPERCENT, PP.SGUNIDADE, SUM(I.VRACRITVEND) AS ACRESCIMO, SUM(I.QTPRODVEND)  AS QTDE,
			     FILOCAVE.NRPESMESAVENDA, SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) - NVL(I.VRDESITVEND,0),2)) AS VALOR,
           TRUNC(((SUM(I.QTPRODVEND)/CASE NVL(FILOCAVE.NRPESMESAVENDA, 1) WHEN 0 THEN 1 END)*100),2)AS PERCENTPES, 
			     P4.CDARVPROD AS CDARVPRODP4, P4.CDPRODUTO AS CDPRODUTOP4, P4.NMPRODUTO AS NMPRODUTOP4, P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4,
    		   P1.CDARVPROD AS CDARVPRODP1, P1.CDPRODUTO AS CDPRODUTOP1, P1.NMPRODUTO AS NMPRODUTOP1, P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1,
    		   P2.CDARVPROD AS CDARVPRODP2, P2.CDPRODUTO AS CDPRODUTOP2, P2.NMPRODUTO AS NMPRODUTOP2, P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2,
    		   P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3, P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3,
    		   PP.CDARVPROD AS CDARVPRODP5, PP.CDPRODUTO AS CDPRODUTOP5, PP.NMPRODUTO AS NMPRODUTOP5, PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
		  FROM ITEMVENDA I
		  JOIN PRODUTO PP
			ON I.CDPRODUTO = PP.CDPRODUTO
		  LEFT JOIN PRODUTO P4
	        ON PP.CDPRODNIVANTE = P4.CDARVPROD
	      LEFT JOIN PRODUTO P3
	        ON P4.CDPRODNIVANTE = P3.CDARVPROD
	      LEFT JOIN PRODUTO P2
	        ON P3.CDPRODNIVANTE = P2.CDARVPROD
	      LEFT JOIN PRODUTO P1
	        ON P2.CDPRODNIVANTE = P1.CDARVPROD
           
		  JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
					   FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, SUM(NVL(V.NRPESMESAVENDA,0)) OVER (PARTITION BY FILOCA.NRORG) AS NRPESMESAVENDA
				  FROM VENDA V
				  JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
						   FROM CAIXA C
						   JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
									FROM LOJA L
									JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
											FROM FILIAL F
											WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
											  AND F.NRORG = :NRORG ) FI
									  ON L.CDFILIAL = FI.CDFILIAL) FILO
							 ON C.CDFILIAL = FILO.CDFILIAL
							AND C.CDLOJA = FILO.CDLOJA
							AND ((INSTR(:CDCAIXA, FILO.CDFILIAL||C.CDCAIXA) <> 0 ) OR (:TCDCAIXA = 'T'))) FILOCA
					 ON V.CDCAIXA = FILOCA.CDCAIXA
					AND V.CDLOJA = FILOCA.CDLOJA
					AND V.CDFILIAL = FILOCA.CDFILIAL
				  WHERE V.IDSITUVENDA = 'O'
					AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
					AND ((INSTR(:CDCLIENTE, V.CDFILIAL||'_'||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
					AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE||'_'||V.CDCONSUMIDOR) <> 0 ) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
			ON FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
		   AND FILOCAVE.CDCAIXA = I.CDCAIXA
		   AND FILOCAVE.CDFILIAL = I.CDFILIAL
		 WHERE I.CDPRODUTO <> NVL(FILOCAVE.CDPRODTAXASERV , 0)		 
		   AND ((INSTR(:CDPRODS, PP.CDARVPROD) <> 0) OR (PP.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF) OR ( :TCDPRODUTO = 'T'))
		 GROUP BY PP.CDARVPROD, PP.NMPRODUTO, PP.CDNVPRODUTO, PP.SGUNIDADE,
              P4.CDARVPROD,P3.CDARVPROD,P2.CDARVPROD,P1.CDARVPROD,P4.CDPRODUTO,P3.CDPRODUTO,P2.CDPRODUTO,P1.CDPRODUTO,P4.NMPRODUTO,P3.NMPRODUTO,P2.NMPRODUTO,P1.NMPRODUTO,
              PP.CDARVPROD, PP.CDPRODUTO, PP.NMPRODUTO, I.CDPRODUTO, FILOCAVE.NRPESMESAVENDA
		 ORDER BY PP.CDARVPROD
	";
}